/*
 *	main.c
 *
 *	P/ECEAvP[V̐^iCLiPCuŁj
 *
 *	* Tue Jul 23 21:01:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER _render;				/* zVRAMւ̕` */
#define render (&_render)

int now;				/* O[o^C} */
int joy;				/* pbh */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(render, &surface, 0, 0, 0, 0, 0, 0, 0);

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5)		/* PAUSEbZ[W̉ */
#define PAUSE_H		10		/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

	int pause, x, y;
	unsigned char save[PAUSE_H][PAUSE_W];

	pause = 0;
	for(;;) {
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */

		/* PAUSEB */
		if(joy & TRG_START) {
			pause ^= 1;	/* PAUSEԐ؂ւ */
			if(pause & 1) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
		if(!(pause & 1)) break;

		/* PAUSEbZ[W_ŕ\B */
		pceFontSetType(PAUSE_FONT);
		pceFontSetTxColor(pause & 2 ? 2 : 3);
		pceFontSetBkColor(pause & 2 ? 0 : 1);
		pceFontSetPos(PAUSE_X, PAUSE_Y);
		pceFontPutStr(PAUSE_STR);
		pause ^= 2;
	}
	now++;	/* O[o^C}XV */

#undef PAUSE_FONT
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	for(;;) {
		schedule();
	}
	return 0;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	for(;;) {
		schedule();
	}
}
